/***************************************************************************
 *   Copyright (C) 2005 by Nicolas Ternisien                               *
 *   nicolas.ternisien@gmail.com                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.             *
 ***************************************************************************/

#include "cronReader.h"

#include <tdelocale.h>
#include <tdemessagebox.h>

CronReader::CronReader(TQObject *parent, const char *name) : 
	DefaultReader(parent, name)
	{
	
}


CronReader::~CronReader() {

}


void CronReader::initColumns(LogViewColumns* columns) {
	columns->append(new LogViewColumn(i18n("Date"), true, false));
	columns->append(new LogViewColumn(i18n("Host Name"), true, true));
	columns->append(new LogViewColumn(i18n("Process"), true, true));
	columns->append(new LogViewColumn(i18n("User"), true, true));
	columns->append(new LogViewColumn(i18n("Message"), true, false));
}


/**
 * TODO Improve speed of this method
 */
LogLine* CronReader::parseMessage(TQString& line, LogFile* logFile) {
	
	//Use the default parsing
	LogLine* logLine=DefaultReader::parseMessage(line, logFile);
	
	
	TQStringList& list=logLine->getItemList();
	
	//Gets the message column (last item) and deletes it
	TQString message=list.back();
	list.pop_back();
	
	int leftBracket=message.find('(');
	int rightBracket=message.find(')');
	
	TQString user=message.mid(leftBracket+1, rightBracket-leftBracket-1);
	
	list.push_back(user);
	
	message=message.right(message.length() - rightBracket-2);
	
	list.push_back(message);
	
	//This log line comes from Cron Reader
	logLine->setType(Globals::cronMode->id);
	
	return(logLine);
}

#include "cronReader.moc"


